namespace JAM
{
	const kStr START_MAP = "levels/ravaged_labyrinth.map";
	const int START_MAP_ID = 63;
	const int START_MAP_WARPTID = 1555;
	array<int> CREDITS_MAPS = {63, 88, 60, 65, 61}; //maps to warp to, and do a fly through. from start to finish.
	array<MapDef@> MAP_DEFS =
	{
		MapDef(id: 63, author: "DoomMarine23", title: "Ravaged Labyrinth",
			creditsWarpTID: 5323, creditsPath: array<kVec3> =
			{
				kVec3(4113.0f, 526.0f, 3185.0f), 		//Start Move Point
				kVec3(4097.0f, 4318.0f, 3185.0f), 		//Start Look Point
				kVec3(4098.0f, 3710.0f, 3029.0f), 		//End Move Point
				kVec3(4098.0f, 4314.0f, 2857.0f) 		//End Look Point
			}
		),
		MapDef(id: 88, author: "operative lm", title: "Arcane Temple",
			creditsWarpTID: 4002, creditsPath: array<kVec3> =
			{
				kVec3(1842.0f, -3075.0f, -2002.0f), 	//Start Move Point
				kVec3(-2649.0f, 2684.0f, -6510.0f), 	//Start Look Point
				kVec3(-1788.0f, 2068.0f, -3038.0f), 	//End Move Point
				kVec3(-3680.0f, 4205.0f, -3038.0f) 		//End Look Point
			}
		),
		MapDef(id: 60, author: "Badger", title: "Atsilv Gulf", warpPortalTIDs: array<int> = {231, 232},
			creditsWarpTID: 115, creditsPath: array<kVec3> =
			{
				kVec3(-662.0f, -1324.0f, 1341.0f), 		//Start Move Point
				kVec3(-662.0f, 4507.0f, 1289.0f), 		//Start Look Point
				kVec3(-664.0f, 1345.0f, 1801.0f), 		//End Move Point
				kVec3(-662.0f, 4507.0f, 1289.0f) 		//End Look Point
			}
		),
		MapDef(id: 68, author: "Badger", title: "Atsilv Gulf Portal 1", isSpiritWorld: true, showCreditsAtStart: false),
		MapDef(id: 69, author: "Badger", title: "Atsilv Gulf Portal 2", isSpiritWorld: true, showCreditsAtStart: false),
		MapDef(id: 65, author: "Smoke39", title: "Jungle Sanctuary", creditsWarpTID: 8, customFlyCreditsScriptID: 9),
		MapDef(id: 61, author: "BehemothProgrammer", title: "Primordial Vale",
			creditsWarpTID: 2614, creditsPath: array<kVec3> =
			{
				kVec3(622.0f, -3313.0f, 865.0f), 		//Start Move Point
				kVec3(622.0f, -75.0f, 865.0f), 			//Start Look Point
				kVec3(622.0f, -75.0f, 865.0f), 			//End Move Point
				kVec3(622.0f, 5550.0f, 441.0f), 		//End Look Point
				kVec3(946.0f, 4176.0f, 937.0f), 		//Next Move Point
				kVec3(622.0f, 5550.0f, 441.0f)	 		//Next Look Point
			}
		)
	};

	MapDef@ GetMapDef(const int mapID)
	{
		for (uint i = 0; i < MAP_DEFS.length(); ++i)
		{
			if (MAP_DEFS[i].id == mapID)
				return MAP_DEFS[i];
		}
		
		return null;
	}
	
	class MapDef
	{
		int id;
		kStr author;
		kStr title;
		bool isSpiritWorld;
		array<int> warpPortalTIDs;
		bool showCreditsAtStart;
		array<kVec3> creditsPath;
		int creditsWarpTID;
		int customFlyCreditsScriptID;
		MapDef()
		{
			customFlyCreditsScriptID = -1;
		}
		
		MapDef(const int id, const kStr &in author = "", const kStr &in title = "", const bool isSpiritWorld = false,
				const array<int> warpPortalTIDs = array<int> = {}, const bool showCreditsAtStart = true, const int creditsWarpTID = -1,
				const array<kVec3> creditsPath = array<kVec3> = {}, const int customFlyCreditsScriptID = -1)
		{
			this.id = id;
			this.author = author;
			this.title = title;
			this.isSpiritWorld = isSpiritWorld;
			this.warpPortalTIDs = warpPortalTIDs;
			this.showCreditsAtStart = showCreditsAtStart;
			this.creditsWarpTID = creditsWarpTID;
			this.creditsPath = creditsPath;
			this.customFlyCreditsScriptID = customFlyCreditsScriptID;
		}
		
		kStr GetCreditsString()
		{
			return "<" + title + ">\n\nBy " + author;
		}

		void PrintCreditLines(const float time)
		{
			HUDPrintLines(array<kStr>={"<" + title + ">", "", "By " + author}, int(time * 60.0f));
		}
	}
}
