#include "scripts/map/map_jam_common.cpp"

//Turok mantis death scream: 	testsoundshader "sounds/shaders/generic_19_turok_mantis_death.ksnd"
//Iggy Ok then: 				testsoundshader "sounds/shaders/generic_168.ksnd"
//I Am Turok: 					testsoundshader "sounds/shaders/generic_234.ksnd"
//Campaigner laughing: 			testsoundshader "sounds/shaders/campainger_shorting_out.ksnd"
//Campaigner Universe is mine: 	testsoundshader "sounds/shaders/campainger_rage.ksnd"
//Campaigner Die: 				testsoundshader "sounds/shaders/campainger_taunt_2.ksnd"

enum EnumMapSpawnParams
{
	SPAWNPARAM_TARGETID = 0,		//-32768 .. 32767
	SPAWNPARAM_TRIGGERANIM = 1,		//     0 .. 255
	SPAWNPARAM_HEALTH = 2,			//-32768 .. 32767
	SPAWNPARAM_MAXREGENS = 3,		//-32768 .. 32767
	SPAWNPARAM_ATTACKCHANCE = 4,	//     0 .. 255
	SPAWNPARAM_TEXTURE = 5,			//  -128 .. 127
	SPAWNPARAM_PARAMS2 = 6,			//  -128 .. 127
	SPAWNPARAM_PARAMS1 = 7			//  -128 .. 127
}

enum EnumMapTags
{
	TAG_SPIRITBRIDGES1 = 1000,
	TAG_SPIRITBRIDGES2 = 1001,
	TAG_PYRMAID_MOVER_START = 1002,
	TAG_PYRMAID_MOVER_END = 1009,
	TAG_PYRMAID_MOVER_1 = 1010,
	TAG_PYRMAID_MOVER_2 = 1011,
	TAG_PYRMAID_MOVER_3 = 1012,
	TAG_PYRMAID_MOVER_4 = 1013,
	TAG_PYRMAID_MOVER_5 = 1014,
	TAG_PYRMAID_BUTTON = 1015,
	TAG_AI_SHAMANS = 1024,
	TAG_AI_SHAMANLEADER = 1025,
	TAG_MONKEYS = 1027,
	TAG_AI_MONKEY_AMBUSH = 1028,
	TAG_MONKEY_PYRAMID = 1029,
	TAG_MONKEY_PYRAMID_PORTAL = 1030,
	TAG_SPIRIT_AMBUSH3 = 1038,
	TAG_RUINS_AMBUSH1 = 1040,
	TAG_RUINS_ENTRANCE_BUTTON = 1041,
	TAG_KEY_DISPLAY_1 = 1043,
	TAG_KEY_1 = 1047,
	TAG_SR_END_PILLARS = 1052,
	TAG_CITY_ENTRANCE_PILLARS = 1053,
	TAG_RUIN_KEY_ELEVATOR = 1057,
	TAG_KEY_DISPLAY_1_BITS = 1060,
	TAG_KEY_1_BITS = 1064,
	TAG_CITY_PORTAL_BARS1 = 1069,
	TAG_CITY_PORTAL_BARS2 = 1072,
	TAG_TREEKEY_BLOCKERMESH = 1080,
	TAG_TREEKEY_BLOCKER = 1081,
	TAG_CAVE_ENTRANCE_ROCK_1 = 1082,
	TAG_CAVE_ENTRANCE_ROCK_FINAL = 1084,
	TAG_CAVE_ENTRANCE_PURLIN = 1085,
	TAG_CAVE_ENTRANCE_POINT = 1086,
	TAG_TREEKEY_CINEMA_TARGET = 1088,
	TAG_PYRAMID_BLOCKER = 1092,
	TAG_PYRAMID_AMBUSH2 = 1093,
	TAG_PYRAMID_AMBUSH3 = 1094,
	TAG_PYRAMID_AMBUSH4 = 1095,
	TAG_PYRAMID_AMBUSH5 = 1096,
	TAG_PYRAMID_AMBUSH6 = 1097,
	TAG_TTB_PREAMBUSH = 1099,
	TAG_TTB_AMBUSH = 1100,
	TAG_START_BIRDS = 1102,
	TAG_START_WARRIORS = 1116,
	TAG_START_WARRIORS_END = 1123,
	TAG_START_RAPTORS = 1124,
	TAG_START_RAPTORS_END = 1127,
	TAG_PYRAMID_AMBUSH7 = 1138,
	TAG_FINAL_AMBUSH = 1141,
	TAG_TTB_PLATFORM = 1142,
	TAG_TTB_FRAME = 1143,
	TAG_TTB_BUTTON = 1144,
	TAG_TTB_PLATFORM1 = 1145,
	TAG_TTB_PLATFORM2 = 1146,
	TAG_SHAMAN_EXPOINT1 = 1147,
	TAG_SHAMAN_EXPOINT2 = 1148,
	TAG_SHAMAN_EXPOINT3 = 1149,
	TAG_SHAMAN_EXPOINT4 = 1150,
	TAG_EVENTLINK1 = 1200,
	TAG_EVENTLINK2 = 1201,
	TAG_EVENTLINK3 = 1202,
	TAG_EVENTLINK4 = 1203,
	TAG_EVENTLINK5 = 1204,
	TAG_EVENTLINK6 = 1205,
	TAG_EVENTLINK7 = 1206,
	TAG_EVENTLINK8 = 1207,
	TAG_EVENTLINK9 = 1208,
	TAG_EVENTLINK10 = 1209,
	TAG_EVENTLINK11 = 1210,
	TAG_EVENTLINK12 = 1211,
	TAG_EVENTLINK13 = 1212,
	TAG_EVENTLINK14 = 1213,
	TAG_EVENTLINK15 = 1214,
	TAG_EVENTLINK16 = 1215,
	TAG_EVENTLINK17 = 1216,
	TAG_EVENTLINK18 = 1217,
	TAG_EVENTLINK19 = 1218,
	TAG_EVENTLINK20 = 1219,
	TAG_EVENTLINK21 = 1220,
	TAG_EVENTLINK22 = 1221,
	TAG_EVENTLINK23 = 1222,
	TAG_EVENTLINK24 = 1223,
	TAG_EVENTLINK25 = 1224,
	TAG_EVENTLINK26 = 1225,
	TAG_EVENTLINK27 = 1226,
	TAG_EVENTLINK28 = 1227,
	TAG_EVENTLINK29 = 1228,
	TAG_EVENTLINK30 = 1229,
	TAG_EVENTLINK31 = 1230,
	TAG_EVENTLINK32 = 1231,
	TAG_EVENTLINK33 = 1232,
	TAG_EVENTLINK34 = 1233,
	TAG_EVENTLINK35 = 1234,
	TAG_EVENTLINK36 = 1235,
	TAG_EVENTLINK37 = 1236,
	TAG_EVENTLINK38 = 1237,
	TAG_EVENTLINK_END = 1300,
}

//TIDs
//2601: Warp Start
//2602: Warp Save
//2603: Checkpoint 1
//2604: Checkpoint 2
//2605: Checkpoint 3
//2606: Checkpoint 4
//2607: Checkpoint 5
//2608: Warp End
//2609: Warp Save 2
//2610: Checkpoint 6
//2611: Checkpoint 7
//2612: Checkpoint 8
//2613: Checkpoint 9
//2614: Credits Fly Through Warp
//1200-1300: EventLinks
//8: Start and End Portal Gates
//100: Everything Else
//1000: Spirit Bridges 1
//1001: Spirit Bridges 2, Wall Break + Purlin
//1002-1009: Pyrmaid perpetual floor movers
//1010-1014: Pyrmaid floor mover 1-5
//1015: Pyrmaid Button
//1016: Mover Down in Temple
//1017-1018: Cave 1 Warps
//1019: Spirit Bridge Warp To
//1020: Temple Warp To
//1021-1022: Ruins To Cave Warps
//1023: Warp from Bottom Waters To Top
//1024: Shamans
//1025: Shaman Leader
//1026: Poacher Ambush
//1027: Monkeys
//1028: Monkey Ambush Enemies
//1029: Monkey Pyrmaid
//1030: Monkey Pyrmaid Item
//1031: Secret Warrior Ambush
//1032: Cave Button To Start, Cave Bars
//1033: Demon Ambush at Temple Entrance
//1034: Purlin ambush at great tree
//1035: Ambush at bridge
//1036: Spirit Bridge Ambush 1 - Purlin
//1037: Spirit Bridge Ambush 2 - Warrior Darts
//1038: Spirit Bridge Ambush 3 - Warrior Darts
//1039: Spirit Bridge Ambush 4 - Purlin
//1040: Ruins Ambush 1 - Purlins + walls
//1041: Ruins Ambush 2 + Button + Doors
//1042: Ruin Cave Bars
//1043-1046: Display Keys
//1047-1050: Keys
//1051: Spirit Ruins Ambush Purlins + walls
//1052: Spirit Ruins End Pillars
//1053: City Entrance Pillars
//1054-1055: Ruin Bridge Warp
//1056: Ruin Button Secret Wall
//1057: Ruin Key Elevator
//1058: Ruin Key Side Elevator 1
//1059: Ruin Key Side Elevator 2
//1060-1063: Display Key Persist Bits
//1064-1067: Key Persist Bits
//1068: Temple Bars
//1069: City Warp Portal Bars 1
//1070: City underwater Button/Bars
//1071: City underwater Warp
//1072: City Warp Portal Bars 2
//1073: Ruins Ambush 3
//1074: Ruins Ambush 4 beetles in wall
//1075: Ruins Ambush 5 Pillar 1
//1076: Ruins Top Button Pillars
//1077: Ruins Ambush 6
//1078: Ruins Ambush 7
//1079: Ruins Ambush 8
//1080: Tree Key Blocker Mesh
//1081: Tree Key Blocker Point
//1082-1084: Ruin Cave Entrance Rocks
//1085: Cave entrance Purlin
//1086: Cave entrance Point
//1087: Cave Stags Destructibles
//1088: Tree Key Cinema LookAt Target
//1089: Monkey 4
//1090: Warp To Spirit Pyramid Trap
//1091: Warp Out of Pyramid Trap
//1092: Monkey Pyramid Block Point
//1093: Monkey Pyramid Ambush 2
//1094: Monkey Pyramid Ambush 3
//1095: Monkey Pyramid Ambush 4
//1096: Monkey Pyramid Ambush 5
//1097: Monkey Pyramid Ambush 6
//1098: Ruins Platform Steps
//1099: Tree Bounce Button, Pillars, Ambush Enemies
//1100: Pillar Platform Button To Treetop + enemies
//1101: Side Pillars + enemy ambush
//1102: Start Birds
//1103: Birds 2
//1104: Monkey 1
//1105: Birds 3
//1106: Monkey 2
//1107: Birds 4
//1108: Birds 5
//1109: Monkey 3
//1110: Birds 6
//1111: Birds 7
//1112: Monkey 5
//1113: Monkey 6
//1114: Monkey 7
//1115: Birds 8, Plant Ambush 2
//1116-1123: Start Warriors
//1124-1127: Start Raptors
//1128: Warp at Tree Bounce
//1129: Warp At Treetop village
//1130: Canyon Enemy Ambush
//1131: Canyon Enemy Ambush 2
//1132: Plant Ambush
//1133: Tree Bounce Entrance Purlin
//1134: Water Hole Ambush
//1135: Ruin Cave Entrance Ambush
//1136: Plains Purlin Ambush
//1137: Bush Guard Ambush
//1138: Pyramid near end ambush
//1139: Plains Ambush on broken pillars
//1140: Side Near Tree Key Ambush
//1141: Final Ambush
//1142: Platform 3 to Treetop
//1143: Button Frame to Treetop
//1144: Button to Treetop
//1145: Platform 1 to Treetop
//1146: Platform 2 to Treetop
//1147: shaman explode point 1
//1148: shaman explode point 2
//1149: shaman explode point 3
//1150: shaman explode point 4
//1151: 

const int KEY_COUNT = 4; //Number of keys to collect in map
const int SCRIPT_SHAMAN_LEADER_CINEMA = 7029;
const int ACTORID_EMITTER_THUNDER = 5028;
const kStr PATH_SOUND_KEY_COLLECT = "sounds/shaders/generic_4_non_weapon_pickup.ksnd";
const kStr PATH_SOUND_KEY_PLACE = "sounds/shaders/health_pickup_1.ksnd";
const kStr PATH_SOUND_EXPLOSION = "sounds/shaders/explosion_2.ksnd";
const kStr PATH_SOUND_TELEPORT = "sounds/shaders/high_priest_teleport.ksnd";
const kStr PATH_SOUND_CITY_ENTRANCE = "sounds/shaders/generic_37_mettalic_moan_1.ksnd";
const kStr PATH_SOUND_SHAMAN_EXPLOSION = "sounds/shaders/generic_157.ksnd";
const kStr PATH_FX_CHRONO_EXPLOSION = "fx/generic_217.kfx";
const kStr PATH_FX_EXPLOSION = "fx/generic_235.kfx";
const kStr PATH_FX_SHAMAN_EXPLOSION = "fx/generic_199.kfx";

const kStr PATH_FX_SHAMAN_EXPOINTS1 = "fx/generic_16.kfx";
const kStr PATH_FX_SHAMAN_EXPOINTS2 = "fx/generic_16.kfx";
const float SHAMAN_EX_TIME1 = 0.05;
const float SHAMAN_EX_TIME2 = 0.04;
const float SHAMAN_EX_SPEED1 = GAME_SCALE * 1.5;
const float SHAMAN_EX_SPEED2 = GAME_SCALE * 3.6;

funcdef bool MAPWAITFUNC();

kPuppet@ playerPuppet;
kActor@ playerActor;
kActor@ shamanLeader;
array<kActor@> startWarriors;
array<kActor@> startRaptors;
uint triggeredScripts;
bool startFinished;
float mapTime;
float displayKeysTime;
float shamanExplosionTime;
//------------------------------------------------------------------------------------------------------------------------
// OnStart
//------------------------------------------------------------------------------------------------------------------------
$script 0
{
	JAM::SetupMap();
		
	@playerPuppet = Player.Actor();
	@playerActor = playerPuppet.CastToActor();
	@shamanLeader = World.GetActorByTID(TAG_AI_SHAMANLEADER);
	kActor@ portal = World.GetActorByTID(TAG_MONKEY_PYRAMID_PORTAL);
	kActor@ ttbPlatform1 = World.GetActorByTID(TAG_TTB_PLATFORM1);
	kActor@ ttbPlatform2 = World.GetActorByTID(TAG_TTB_PLATFORM2);	
	
	if (ActorExists(ttbPlatform1))
	{
		if (ttbPlatform1.RenderModel() !is null)
			ttbPlatform1.RenderModel().Offset() = kVec3(0, 0, -51.2);
		ttbPlatform1.Flags() |= AF_NODRAW | AF_ALWAYSACTIVE;
	}
	if (ActorExists(ttbPlatform2))
	{
		if (ttbPlatform2.RenderModel() !is null)
			ttbPlatform2.RenderModel().Offset() = kVec3(0, 0, -51.2);
		ttbPlatform2.Flags() |= AF_NODRAW | AF_ALWAYSACTIVE;
	}
	
	if (ActorExists(portal))
		portal.Flags() |= AF_HIDDEN;

	array<kActor@> actors;
	
	// Flip Pyrmaid model for elevators
	actors = FindActors(TAG_PYRMAID_MOVER_1, TAG_PYRMAID_MOVER_5);
	for (uint i = 0; i < actors.length(); i++)
	{
		actors[i].Pitch() = Math::Deg2Rad(180.0f);
	}

	// Activate the misc_pyrmaid01 Perpetual Floor Movers and flip them
	actors = FindActors(TAG_PYRMAID_MOVER_START, TAG_PYRMAID_MOVER_END);
	for (uint i = 0; i < actors.length(); i++)
	{
		World.TriggerActorsByTID(instigator, actors[i].TID());
		actors[i].Pitch() = Math::Deg2Rad(180.0f);
	}
	
	//EventLinks
	actors = FindActors(TAG_EVENTLINK1, TAG_EVENTLINK_END);
	for (uint i = 0; i < actors.length(); i++)
	{
		if (actors[i].IsPersistentMarked())
			EventLinkTriggerTarget(actors[i]);
	}
	
	//Make Shaman Leader stand still while animated and invincible
	if (ActorExists(shamanLeader))
	{
		shamanLeader.CastToAI().AIFlags() |= AIF_NOTHINK;
	}

	//Make keys at gate untouchable and hidden and make collectable keys untouchable
	for (uint i = 0; i < KEY_COUNT; i++)
	{
		kActor@ keyDisplay = World.GetActorByTID(TAG_KEY_DISPLAY_1 + i);
		kActor@ keyDisplayBit = World.GetActorByTID(TAG_KEY_DISPLAY_1_BITS + i);
		kActor@ key = World.GetActorByTID(TAG_KEY_1 + i);
		kActor@ keyBit = World.GetActorByTID(TAG_KEY_1_BITS + i);
		
		if (ActorExists(keyDisplay))
		{
			keyDisplay.Flags() &= ~AF_CANBETOUCHED;
			if (ActorExists(keyDisplayBit) && !keyDisplayBit.IsPersistentMarked())
				keyDisplay.Flags() |= AF_HIDDEN;
		}
		
		if (ActorExists(key))
		{
			key.Flags() &= ~AF_CANBETOUCHED;
			if (ActorExists(keyBit) && keyBit.IsPersistentMarked())
				key.Flags() |= AF_HIDDEN;
		}
	}
	
	Game.CallDelayedMapScript(1, instigator, 0.0f); //Start Map OnTick
	
	delay(0.0f);
	startFinished = true;
}
//------------------------------------------------------------------------------------------------------------------------
// OnTick
//------------------------------------------------------------------------------------------------------------------------
$script 1
{
	mapTime += GAME_DELTA_TIME;
    $restart;
}
//------------------------------------------------------------------------------------------------------------------------
// Spirit Bridge Area Elevator 1
//------------------------------------------------------------------------------------------------------------------------
$script 7000
{
	if (instigator.OnGround())
		World.TriggerActorsByTID(instigator, TAG_PYRMAID_MOVER_1);
	World.TriggerActorsByTID(instigator, TAG_SPIRITBRIDGES1);
	EventLinkTrigger(TAG_EVENTLINK11);
}
//------------------------------------------------------------------------------------------------------------------------
// Spirit Bridge Area Button
//------------------------------------------------------------------------------------------------------------------------
$script 7001
{
	if (startFinished && !instigator.OnGround()) return;
	if (HasTriggeredScript(1)) return;

	bool wasTriggered = EventLinkTrigger(TAG_EVENTLINK5, false);
	World.TriggerActorsByTID(instigator, TAG_PYRMAID_BUTTON);
	World.TriggerActorsByTID(instigator, TAG_PYRMAID_MOVER_3);
	World.TriggerActorsByTID(instigator, TAG_PYRMAID_MOVER_4);
	if (!wasTriggered)
		delay(2.0f);
	World.TriggerActorsByTID(instigator, TAG_PYRMAID_MOVER_2);
	World.TriggerActorsByTID(instigator, TAG_SPIRIT_AMBUSH3);
}
//------------------------------------------------------------------------------------------------------------------------
$script 7002 { EventLinkTrigger(TAG_EVENTLINK1); }
//------------------------------------------------------------------------------------------------------------------------
// Activate Shamans
//------------------------------------------------------------------------------------------------------------------------
$script 7003
{
	if (HasTriggeredScript(3)) return;
	
	bool wasTriggered = EventLinkTrigger(TAG_EVENTLINK2, false);
	World.TriggerActorsByTID(instigator, TAG_AI_SHAMANS);
	
	//Activate Shaman/Add lightning fx
	if (ActorExists(shamanLeader) && !ActorIsDead(shamanLeader))
	{
		Game.CallDelayedMapScript(SCRIPT_SHAMAN_LEADER_CINEMA, instigator, 0.0f); //Start Update Check if Shaman Leader is dead
		
		shamanLeader.CastToAI().AIFlags() &= ~AIF_NOTHINK;
		if (!wasTriggered)
		{
			shamanLeader.SpawnFx(PATH_FX_SHAMAN_EXPLOSION, Math::vecZero);
			shamanLeader.SpawnFx(PATH_FX_SHAMAN_EXPLOSION, kVec3(0.0f, 0.0f, 150.0f));
			shamanLeader.PlaySound(PATH_SOUND_SHAMAN_EXPLOSION);
			
			kActor@ emitterThunder = ActorSpawn(ACTORID_EMITTER_THUNDER, shamanLeader);
			
			delay(1.0f);
			
			kVec3 vel = (playerActor.Origin() - shamanLeader.Origin()).Normalize() * 20.0f;
			vel.z = 12.0f;
			playerActor.Velocity() = vel;
			playerActor.Origin().z += GAME_SCALE;
			playerPuppet.PlayerFlags() |= PF_NOAIRFRICTION;

			
			delay(15.0f);
			emitterThunder.Remove();
		}
	}
	else
	{
		RemoveTreeBlocker();
	}
}
//------------------------------------------------------------------------------------------------------------------------
$script 7004 { if (HasTriggeredScript(4)) return; EventLinkTrigger(TAG_EVENTLINK3); }
//------------------------------------------------------------------------------------------------------------------------
// Activate Monkeys
//------------------------------------------------------------------------------------------------------------------------
$script 7005
{
	if (HasTriggeredScript(5)) return;
	
	bool wasTriggered = EventLinkTrigger(TAG_EVENTLINK4, false);
	kActor@ portal = World.GetActorByTID(TAG_MONKEY_PYRAMID_PORTAL);
	kActor@ blocker = World.GetActorByTID(TAG_PYRAMID_BLOCKER);
	if (wasTriggered)
	{
		if (ActorExists(blocker))
			World.FloodMatchingAreaFlags(blocker.SectorIndex(), AAF_BLOCK, false);
		if (ActorExists(portal))
		{
			portal.Flags() &= ~AF_HIDDEN;
			portal.RunFxEvent("Portal_Init");
		}
	}
	
	World.TriggerActorsByTID(instigator, TAG_MONKEYS);
	World.TriggerActorsByTID(instigator, TAG_MONKEY_PYRAMID);
	kActor@ emitterThunder;
	if (!wasTriggered)
	{
		if (ActorExists(portal))
			@emitterThunder = ActorSpawn(ACTORID_EMITTER_THUNDER, portal);
		delay(1.5f);
	}
	
	World.TriggerActorsByTID(instigator, TAG_AI_MONKEY_AMBUSH);
	if (wasTriggered)
		World.TriggerActorsByTID(instigator, TAG_PYRAMID_AMBUSH2);
	
	delay(8.0f);
	if (!wasTriggered)
		World.TriggerActorsByTID(instigator, TAG_PYRAMID_AMBUSH2);
	delay(5.0f);
	
	if (ActorExists(emitterThunder))
		emitterThunder.Remove();
	
	if (!wasTriggered)
	{
		if (ActorExists(blocker))
			World.FloodMatchingAreaFlags(blocker.SectorIndex(), AAF_BLOCK, false);
		if (ActorExists(portal))
		{
			portal.Flags() &= ~AF_HIDDEN;
			portal.RunFxEvent("Portal_Init");
		}
	}
}
//------------------------------------------------------------------------------------------------------------------------
$script 7006 { if (HasTriggeredScript(6)) return; EventLinkTrigger(TAG_EVENTLINK6); }
//------------------------------------------------------------------------------------------------------------------------
$script 7007 { if (HasTriggeredScript(7)) return; EventLinkTrigger(TAG_EVENTLINK7); }
//------------------------------------------------------------------------------------------------------------------------
$script 7008 { if (HasTriggeredScript(8)) return; EventLinkTrigger(TAG_EVENTLINK8); }
//------------------------------------------------------------------------------------------------------------------------
$script 7009 { if (HasTriggeredScript(9)) return; EventLinkTrigger(TAG_EVENTLINK9); }
//------------------------------------------------------------------------------------------------------------------------
$script 7010
{
	World.TriggerActorsByTID(instigator, TAG_SPIRITBRIDGES1);
	
	if (HasTriggeredScript(10))
		return;
	
	EventLinkTrigger(TAG_EVENTLINK10);
}
//------------------------------------------------------------------------------------------------------------------------
$script 7011 { if (HasTriggeredScript(11)) return; EventLinkTrigger(TAG_EVENTLINK12); }
//------------------------------------------------------------------------------------------------------------------------
$script 7012
{
	if (startFinished && !instigator.OnGround()) return;
	if (HasTriggeredScript(12)) return;
	
	bool wasTriggered = EventLinkTrigger(TAG_EVENTLINK13, false);
	World.TriggerActorsByTID(instigator, TAG_RUINS_AMBUSH1);
}
//------------------------------------------------------------------------------------------------------------------------
$script 7013
{
	if (HasTriggeredScript(13))
		return;
	
	bool wasTriggered = EventLinkTrigger(TAG_EVENTLINK14, false);
	World.TriggerActorsByTID(instigator, TAG_RUINS_ENTRANCE_BUTTON);
	if (!wasTriggered)
	{
		if (ActorExists(playerActor))
			playerActor.PlaySound(PATH_SOUND_TELEPORT);
	}
}
//------------------------------------------------------------------------------------------------------------------------
// Entered Collect Key 2 area
//------------------------------------------------------------------------------------------------------------------------
$script 7014
{
	if (HasTriggeredScript(14)) return;
	
	CollectKey(1);
	World.TriggerActorsByTID(instigator, TAG_SR_END_PILLARS);
}
//------------------------------------------------------------------------------------------------------------------------
$script 7015 { if (HasTriggeredScript(15)) return; EventLinkTrigger(TAG_EVENTLINK15); }
//------------------------------------------------------------------------------------------------------------------------
// Entered Place Key 1 area
//------------------------------------------------------------------------------------------------------------------------
$script 7016 { PlaceKey(0); }
//------------------------------------------------------------------------------------------------------------------------
// Entered Place Key 2 area
//------------------------------------------------------------------------------------------------------------------------
$script 7017 { PlaceKey(1); }
//------------------------------------------------------------------------------------------------------------------------
// Entered Place Key 3 area
//------------------------------------------------------------------------------------------------------------------------
$script 7018 { PlaceKey(2); }
//------------------------------------------------------------------------------------------------------------------------
// Entered Place Key 4 area
//------------------------------------------------------------------------------------------------------------------------
$script 7019 { PlaceKey(3); }
//------------------------------------------------------------------------------------------------------------------------
// Entered Collect Key 4 area
//------------------------------------------------------------------------------------------------------------------------
$script 7020
{
	CollectKey(3);
	World.TriggerActorsByTID(instigator, TAG_RUIN_KEY_ELEVATOR);
}
//------------------------------------------------------------------------------------------------------------------------
// Entered Collect Key 1 area
//------------------------------------------------------------------------------------------------------------------------
$script 7021
{
	if (HasTriggeredScript(16))
		return;
	
	CollectKey(0);
}
//------------------------------------------------------------------------------------------------------------------------
// Entered Collect Key 3 area
//------------------------------------------------------------------------------------------------------------------------
$script 7022
{
	if (HasTriggeredScript(17))
		return;
	
	CollectKey(2);
}
//------------------------------------------------------------------------------------------------------------------------
$script 7023 { if (HasTriggeredScript(18)) return; EventLinkTrigger(TAG_EVENTLINK16); }
//------------------------------------------------------------------------------------------------------------------------
$script 7024 { if (HasTriggeredScript(19)) return; EventLinkTrigger(TAG_EVENTLINK17); }
//------------------------------------------------------------------------------------------------------------------------
$script 7025 { if (HasTriggeredScript(20)) return; EventLinkTrigger(TAG_EVENTLINK18); }
//------------------------------------------------------------------------------------------------------------------------
$script 7026 { if (HasTriggeredScript(21)) return; EventLinkTrigger(TAG_EVENTLINK19); }
//------------------------------------------------------------------------------------------------------------------------
$script 7027 { if (HasTriggeredScript(22)) return; EventLinkTrigger(TAG_EVENTLINK20); }
//------------------------------------------------------------------------------------------------------------------------
$script 7028 { if (HasTriggeredScript(23)) return; EventLinkTrigger(TAG_EVENTLINK21); }
//------------------------------------------------------------------------------------------------------------------------
// Update Check if Shaman Leader is dead
//------------------------------------------------------------------------------------------------------------------------
$script 7029 //SCRIPT_SHAMAN_LEADER_CINEMA
{
	if (!ActorExists(shamanLeader) || ActorIsDead(shamanLeader))
	{
		kActor@ treeBlocker = World.GetActorByTID(TAG_TREEKEY_BLOCKER);
		kActor@ lookAtTarget = World.GetActorByTID(TAG_TREEKEY_CINEMA_TARGET);
		if (ActorExists(treeBlocker) && ActorExists(lookAtTarget) && !treeBlocker.IsPersistentMarked())
		{
			delay(1.5f);
			CinemaStart();
			kVec3 camStartPos = kVec3(600.0f, -7400.0f, 837.0f);
			Camera.SetLookAtActor(lookAtTarget);
			Camera.SetFinalView(0);
			Camera.SetPositionTrack(1, camStartPos, camStartPos, camStartPos, camStartPos);
			Camera.AutoPlayPositionTrack(1, 6.0f, CMLT_COSINE);
			Camera.SetRotationTrack(2,
									Math::Deg2Rad(35.0f),	// start angle
									Math::Deg2Rad(75.0f),	// dest angle
									135.0f*GAME_SCALE,		// start distance
									135.0f*GAME_SCALE,		// dest distance
									70.0f*GAME_SCALE,		// start height
									40.0f*GAME_SCALE,		// dest height
									0.0f,					// start look at height
									0.0f);					// dest look at height
			Camera.AutoPlayRotationTrack(2, 6.0f, CMLT_COSINE);
			Camera.AutoPlayBlendTrack(0, 1, 2, 6.0f, CMLT_COSINE);
			WaitUntil(CinemaIsShowing);
			ShowPlayer(Player.Actor().CastToActor(), 2817, 2);
			Game.CallDelayedMapScript(7053, instigator, 0.0f); //Update Explosions 1
			delay(6.0f);
			RemoveTreeBlocker();
			delay(4.0f);
			CinemaStop();
		}
		else
		{
			RemoveTreeBlocker();
		}

		return;
	}
	
	$restart;
}
//------------------------------------------------------------------------------------------------------------------------
// Entered Cave Entrance Rock Sectors
//------------------------------------------------------------------------------------------------------------------------
$script 7030
{
	if (HasTriggeredScript(24))
		return;
	
	bool wasTriggered = EventLinkTrigger(TAG_EVENTLINK22, false);
	World.TriggerActorsByTID(instigator, TAG_CAVE_ENTRANCE_PURLIN);
	
	array<kActor@> rocks = FindActors(TAG_CAVE_ENTRANCE_ROCK_1, TAG_CAVE_ENTRANCE_ROCK_FINAL);
	if (wasTriggered)
	{
		for (uint i = 0; i < rocks.length(); i++)
			rocks[i].Remove();
	}
	else
	{
		kActor@ caveEntrancePoint = World.GetActorByTID(TAG_CAVE_ENTRANCE_POINT);
		kVec3 entrancePos = kVec3(4157.439941f, -3686.399902f, 0.0f);
		if (ActorExists(caveEntrancePoint))
		{
			entrancePos = caveEntrancePoint.Origin();
			caveEntrancePoint.SpawnFx(PATH_FX_EXPLOSION, Math::vecZero);
			caveEntrancePoint.PlaySound(PATH_SOUND_EXPLOSION);
		}
		
		for (uint i = 0; i < rocks.length(); i++)
		{
			rocks[i].Friction() = 0.5f;
			rocks[i].BounceDamp() = 0.3f;
			rocks[i].Gravity() = 0.2f;
			rocks[i].ClipFlags() |= CF_CLIPEDGES | CF_IGNOREBLOCKERS | CF_DROPOFF | CF_WALKWALLS | CF_COLLIDEFLOORS | CF_NOSLOPESTEP | CF_COLLIDEHEIGHT | CF_NOFLOORADJUST | CF_NOCEILINGADJUST;
			rocks[i].Velocity() = kVec3(Math::RandRange(-3.0f, -10.0f), Math::RandRange(-10.0f, 10.0f), Math::RandRange(5.0f, 10.0f));
		}
		
		delay(3.0f);
		
		//make sure rocks are not near entrance or behind it (in the cave)
		for (uint i = 0; i < rocks.length(); i++)
		{
			if (rocks[i].Origin().x > entrancePos.x || ActorInRange(rocks[i], entrancePos, 160.0f))
			{
				rocks[i].SpawnFx(PATH_FX_EXPLOSION, Math::vecZero);
				rocks[i].PlaySound(PATH_SOUND_EXPLOSION);
				rocks[i].Remove();
			}
		}
	}
}
//------------------------------------------------------------------------------------------------------------------------
// Entered Pyramid Spirit Area
//------------------------------------------------------------------------------------------------------------------------
$script 7031
{
	if (HasTriggeredScript(25))
		return;
	
	bool wasTriggered = EventLinkTrigger(TAG_EVENTLINK23, false);
	World.TriggerActorsByTID(instigator, TAG_PYRAMID_AMBUSH3);
	if (!wasTriggered) delay(2.0f);
	World.TriggerActorsByTID(instigator, TAG_PYRAMID_AMBUSH4);
	if (!wasTriggered) delay(2.0f);
	World.TriggerActorsByTID(instigator, TAG_PYRAMID_AMBUSH5);
	if (!wasTriggered) delay(2.0f);
	World.TriggerActorsByTID(instigator, TAG_PYRAMID_AMBUSH6);
}
//------------------------------------------------------------------------------------------------------------------------
// Empty Area (used for movers, differentiating the sectors.)
//------------------------------------------------------------------------------------------------------------------------
$script 7032 {}
//------------------------------------------------------------------------------------------------------------------------
// In Tree Bounce Area
//------------------------------------------------------------------------------------------------------------------------
$script 7033
{
	if (instigator.Origin().z < -510.0f)
	{
		float velZ = instigator.Velocity().z;
		float posVelZ = -Math::Fabs(instigator.Origin().z - instigator.PrevOrigin().z);
		velZ = Math::Min(velZ, posVelZ);
		instigator.Velocity().z = Math::Max(-velZ + 10.0f, 38.0f);
		if (velZ < -56.0f)
			instigator.PlaySound("sounds/shaders/generic_19_turok_mantis_death.ksnd"); //"sounds/shaders/generic_178.ksnd");
		else
			instigator.PlaySound("sounds/shaders/bow_stretch.ksnd");
	}
	else if (instigator.Origin().z > 4580.0f)
	{
		instigator.PlaySound(PATH_SOUND_TELEPORT);
		PlayLoop.StartWarp(instigator, 1129, Game.GetCurrentMapID());
	}
}
//------------------------------------------------------------------------------------------------------------------------
// Left the Tree Bounce Area
//------------------------------------------------------------------------------------------------------------------------
$script 7034
{
	if (instigator.Velocity().z > 15.0f)
		instigator.Velocity().z = 15.0f;
}
//------------------------------------------------------------------------------------------------------------------------
// Start Area
//------------------------------------------------------------------------------------------------------------------------
$script 7035
{
	if (HasTriggeredScript(26))
		return;
	
	EventLinkTrigger(TAG_EVENTLINK24, false);
	World.TriggerActorsByTID(instigator, TAG_START_BIRDS);
	startWarriors = FindActors(TAG_START_WARRIORS, TAG_START_WARRIORS_END);
	startRaptors = FindActors(TAG_START_RAPTORS, TAG_START_RAPTORS_END);
	
	//Activate Warriors Ambush
	for (uint i = 0; i < startWarriors.length(); i++)
		World.TriggerActorsByTID(instigator, startWarriors[i].TID());
	
	Game.CallDelayedMapScript(7036, instigator, 0.0f); //Update Start Area Battle
}
//------------------------------------------------------------------------------------------------------------------------
// Update Start Area Battle
//------------------------------------------------------------------------------------------------------------------------
$script 7036
{
	//Remove Dead or Stale Warriors
	for (int i = int(startWarriors.length()) - 1; i >= 0; i--)
	{
		if (!ActorExists(startWarriors[i]) || ActorIsDead(startWarriors[i]))
			startWarriors.removeAt(i);
	}
	//Remove Dead or Stale Raptors
	for (int i = int(startRaptors.length()) - 1; i >= 0; i--)
	{
		if (!ActorExists(startRaptors[i]) || ActorIsDead(startRaptors[i]))
			startRaptors.removeAt(i);
	}
	
	if (startWarriors.length() == 0 || startRaptors.length() == 0)
		return; //battle over
	
	if (!Player.Locked() && !Camera.Active())
	{
		for (uint i = 0; i < startWarriors.length(); i++)
		{
			kActor@ target = startWarriors[i].GetTarget();
			
			if (target is null || (ActorExists(target) && target.Type() != 1)) //AT_RAPTOR
			{
				@target = startRaptors[ArrayRandomIndex(startRaptors.length())];
				startWarriors[i].InflictGenericDamage(target, 0);
			}
			if (ActorExists(target))
				startWarriors[i].SetHeadTrackTarget(target);
		}
		
		for (uint i = 0; i < startRaptors.length(); i++)
		{
			kActor@ target = startRaptors[i].GetTarget();
			if (target is null || (ActorExists(target) && target.Type() != 2)) //AT_GRUNT
			{
				@target = startWarriors[ArrayRandomIndex(startWarriors.length())];
				startRaptors[i].InflictGenericDamage(target, 0);
			}
			if (ActorExists(target))
				startRaptors[i].SetHeadTrackTarget(target);
		}
	}
	
	$restart;
}
//------------------------------------------------------------------------------------------------------------------------
$script 7037 { EventLinkTrigger(TAG_EVENTLINK25); }
//------------------------------------------------------------------------------------------------------------------------
$script 7038 { EventLinkTrigger(TAG_EVENTLINK26); }
//------------------------------------------------------------------------------------------------------------------------
$script 7039 { EventLinkTrigger(TAG_EVENTLINK27); }
//------------------------------------------------------------------------------------------------------------------------
$script 7040 { EventLinkTrigger(TAG_EVENTLINK28); }
//------------------------------------------------------------------------------------------------------------------------
$script 7041 { EventLinkTrigger(TAG_EVENTLINK29); }
//------------------------------------------------------------------------------------------------------------------------
$script 7042 { EventLinkTrigger(TAG_EVENTLINK30); }
//------------------------------------------------------------------------------------------------------------------------
$script 7043
{
	if (HasTriggeredScript(29))
		return;
	
	bool wasTriggered = EventLinkTrigger(TAG_EVENTLINK31, false);

	World.TriggerActorsByTID(instigator, TAG_TTB_PREAMBUSH);
	World.TriggerActorsByTID(instigator, TAG_TTB_PLATFORM1);
	World.TriggerActorsByTID(instigator, TAG_TTB_PLATFORM2);
	
	//make the final platform and the button actors appear
	kActor@ ttbPlatform1 = World.GetActorByTID(TAG_TTB_PLATFORM1);
	kActor@ ttbPlatform2 = World.GetActorByTID(TAG_TTB_PLATFORM2);	
	if (ActorExists(ttbPlatform1))
	{
		ttbPlatform1.Flags() &= ~AF_NODRAW;
		ttbPlatform1.MarkPersistentBit(true);
	}
	if (ActorExists(ttbPlatform2))
	{
		ttbPlatform2.Flags() &= ~AF_NODRAW;
		ttbPlatform2.MarkPersistentBit(true);
	}
}
//------------------------------------------------------------------------------------------------------------------------
$script 7044 { EventLinkTrigger(TAG_EVENTLINK32); }
//------------------------------------------------------------------------------------------------------------------------
$script 7045
{
	World.TriggerActorsByTID(instigator, TAG_SPIRITBRIDGES1);
	World.TriggerActorsByTID(instigator, TAG_PYRAMID_AMBUSH7);
}
//------------------------------------------------------------------------------------------------------------------------
$script 7046 { EventLinkTrigger(TAG_EVENTLINK33); }
//------------------------------------------------------------------------------------------------------------------------
$script 7047 { JAM::BeatTheGame(); }
//------------------------------------------------------------------------------------------------------------------------
$script 7048 { EventLinkTrigger(TAG_EVENTLINK34); }
//------------------------------------------------------------------------------------------------------------------------
// Final Button 1
//------------------------------------------------------------------------------------------------------------------------
$script 7049
{
	if (HasTriggeredScript(27))
		return;
	
	EventLinkTrigger(TAG_EVENTLINK35);
	World.TriggerActorsByTID(instigator, TAG_CITY_PORTAL_BARS1);
	
	kActor@ actor = World.GetActorByTID(TAG_EVENTLINK36);
	if (ActorExists(actor) && actor.IsPersistentMarked())
		World.TriggerActorsByTID(instigator, TAG_FINAL_AMBUSH);
}
//------------------------------------------------------------------------------------------------------------------------
// Final Button 2
//------------------------------------------------------------------------------------------------------------------------
$script 7050
{
	if (HasTriggeredScript(28))
		return;
	
	EventLinkTrigger(TAG_EVENTLINK36);
	World.TriggerActorsByTID(instigator, TAG_CITY_PORTAL_BARS2);
	
	kActor@ actor = World.GetActorByTID(TAG_EVENTLINK35);
	if (ActorExists(actor) && actor.IsPersistentMarked())
		World.TriggerActorsByTID(instigator, TAG_FINAL_AMBUSH);
}
//------------------------------------------------------------------------------------------------------------------------
$script 7051 { EventLinkTrigger(TAG_EVENTLINK37); }
//------------------------------------------------------------------------------------------------------------------------
$script 7052
{
	bool wasTriggered = EventLinkTrigger(TAG_EVENTLINK38, false);
	World.TriggerActorsByTID(instigator, TAG_TTB_AMBUSH);
	World.TriggerActorsByTID(instigator, TAG_TTB_BUTTON);
}
//------------------------------------------------------------------------------------------------------------------------
// Update Shaman Leader Dead Explosions 1
//------------------------------------------------------------------------------------------------------------------------
$script 7053
{
	if (TimeReached(shamanExplosionTime))
	{
		shamanExplosionTime = TimeFromNow(SHAMAN_EX_TIME1);

		//move towards center point then create shockwave
		bool reachedTarget = false;
		kVec3 targetPoint(1648.0, -6758.0, 216.0);
		array<kActor@> exPoints = FindActors(TAG_SHAMAN_EXPOINT1, TAG_SHAMAN_EXPOINT4);
		if (exPoints.length() == 0)
			return;
		
		for (uint i = 0; i < exPoints.length(); i++)
		{
			kActor@ point = exPoints[i];
			point.SpawnFx(PATH_FX_SHAMAN_EXPOINTS1, Math::vecZero);
			kVec3 dir = targetPoint - point.Origin();
			if (point.Origin().Distance(targetPoint) <= SHAMAN_EX_SPEED1)
				reachedTarget = true;
			point.Origin() = point.Origin() + dir.Normalize() * (SHAMAN_EX_SPEED1);
		}
		
		if (reachedTarget)
		{
			if (exPoints.length() > 0)
			{
				exPoints[0].Origin() = targetPoint;
				exPoints[0].SpawnFx(PATH_FX_SHAMAN_EXPLOSION, Math::vecZero);
			}
			shamanExplosionTime = TimeFromNow(SHAMAN_EX_TIME2);
			Game.CallDelayedMapScript(7054, instigator, 0.0f); //Update Explosions 2
			
			return;
		}
	}
	
	$restart;
}
//------------------------------------------------------------------------------------------------------------------------
// Update Shaman Leader Dead Explosions 2
//------------------------------------------------------------------------------------------------------------------------
$script 7054
{
	if (TimeReached(shamanExplosionTime))
	{
		shamanExplosionTime = TimeFromNow(SHAMAN_EX_TIME2);
		kActor@ actor = World.GetActorByTID(TAG_SHAMAN_EXPOINT1);
		if (ActorExists(actor))
		{
			kVec3 targetPoint(3964.0, -6946.0, 276.0);
			actor.SpawnFx(PATH_FX_SHAMAN_EXPOINTS2, Math::vecZero);
			kVec3 dir = targetPoint - actor.Origin();
			if (actor.Origin().Distance(targetPoint) <= SHAMAN_EX_SPEED2)
			{
				//reached target
				return;
			}
			actor.Origin() = actor.Origin() + dir.Normalize() * SHAMAN_EX_SPEED2;
		}
		else
		{
			return;
		}
	}
	
	$restart;
}
//------------------------------------------------------------------------------------------------------------------------
bool ActorInRange(kActor@ actor, const kVec3 &in pos, const float range)
{
	return actor.Origin().DistanceSq(pos) < range * range;
}
//------------------------------------------------------------------------------------------------------------------------
int ArrayRandomIndex(const uint length)
{
	return Math::RandMax(int(length));
}
//------------------------------------------------------------------------------------------------------------------------
void CinemaStart(const uint cinFlags = CMF_LOCK_PLAYER|CMF_UNLOCK_PLAYER_ON_FINISH, const float fov = 74.0f)
{
	kActor@ pActor = Player.Actor().CastToActor();
	pActor.Flags() |= AF_NODRAW;
	pActor.AnimState().Stop();
	Camera.ClearLookAtActor();
	Camera.ClearFinalView();
	Camera.ClearViewTracks();
	Camera.StartCinematic(cinFlags);
	Camera.fov = fov;
}
//------------------------------------------------------------------------------------------------------------------------
void CinemaStop(const bool waitUntilFinished = true)
{
	Camera.StopCinematic();
	if (waitUntilFinished)
		WaitUntil(CinemaIsFinished);
	Camera.ClearLookAtActor();
	kActor@ pActor = Player.Actor().CastToActor();
	pActor.Flags() |= AF_NODRAW;
	pActor.AnimState().Stop();
}
//------------------------------------------------------------------------------------------------------------------------
void RemoveTreeBlocker()
{
	kActor@ treeBlocker = World.GetActorByTID(TAG_TREEKEY_BLOCKER);
	if (ActorExists(treeBlocker))
	{
		if (!treeBlocker.IsPersistentMarked())
		{
			treeBlocker.MarkPersistentBit(false);
			kActor@ lookAtTarget = World.GetActorByTID(TAG_TREEKEY_CINEMA_TARGET);
			if (ActorExists(lookAtTarget))
				lookAtTarget.SpawnFx(PATH_FX_CHRONO_EXPLOSION, Math::vecZero);
			delay(0.5f);
		}
		World.FloodMatchingAreaFlags(treeBlocker.SectorIndex(), AAF_BLOCK, false);
	}
	
	//remove tree door mesh
	kActor@ treeBlockerMesh = World.GetActorByTID(TAG_TREEKEY_BLOCKERMESH);
	if (ActorExists(treeBlockerMesh))
		treeBlockerMesh.Remove();
}
//------------------------------------------------------------------------------------------------------------------------
bool HasTriggeredScript(const uint index)
{
	if (triggeredScripts & (1 << index) == 0)
	{
		triggeredScripts |= (1 << index);
		return false;
	}
	
	return true;
}
//------------------------------------------------------------------------------------------------------------------------
void CollectKey(const int index)
{
	kActor@ keyBit = World.GetActorByTID(TAG_KEY_1_BITS + index);
	if (ActorExists(keyBit) && !keyBit.IsPersistentMarked())
	{
		keyBit.MarkPersistentBit(false);
		kActor@ key = World.GetActorByTID(TAG_KEY_1 + index);
		if (ActorExists(key))
		{
			key.Flags() |= AF_HIDDEN;
			key.PlaySound(PATH_SOUND_KEY_COLLECT);
			DisplayKeysRemaining();
		}
	}
}
//------------------------------------------------------------------------------------------------------------------------
// Place key at Gate Area if not already placed
//------------------------------------------------------------------------------------------------------------------------
void PlaceKey(const int index)
{
	if (!HasKey(index))
	{
		DisplayKeysRemaining();
		return;
	}
	
	kActor@ keyDisplayBit = World.GetActorByTID(TAG_KEY_DISPLAY_1_BITS + index);
	if (ActorExists(keyDisplayBit) && !keyDisplayBit.IsPersistentMarked())
	{
		keyDisplayBit.MarkPersistentBit(false);
		kActor@ keyDisplay = World.GetActorByTID(TAG_KEY_DISPLAY_1 + index);
		if (ActorExists(keyDisplay))
		{
			keyDisplay.Flags() &= ~AF_HIDDEN;
			keyDisplay.PlaySound(PATH_SOUND_KEY_PLACE);
			if (GetRemainingKeysToPlace() <= 0)
			{
				World.TriggerActorsByTID(playerActor, TAG_CITY_ENTRANCE_PILLARS);
				if (ActorExists(playerActor))
				{
					delay(0.5f);
					playerActor.PlaySound(PATH_SOUND_CITY_ENTRANCE);
				}
			}
		}
	}
}
//------------------------------------------------------------------------------------------------------------------------
bool HasKey(const int index)
{
	kActor@ actor = World.GetActorByTID(TAG_KEY_1_BITS + index);
	return ActorExists(actor) && actor.IsPersistentMarked();
}
//------------------------------------------------------------------------------------------------------------------------
int GetRemainingKeys()
{
	int remainingKeys = KEY_COUNT;
	for (int i = 0; i < KEY_COUNT; i++)
	{
		kActor@ actor = World.GetActorByTID(TAG_KEY_1_BITS + i);
		if (ActorExists(actor) && actor.IsPersistentMarked())
			remainingKeys--;
	}
	
	return remainingKeys;
}
//------------------------------------------------------------------------------------------------------------------------
int GetRemainingKeysToPlace()
{
	int remainingKeys = KEY_COUNT;
	for (int i = 0; i < KEY_COUNT; i++)
	{
		kActor@ actor = World.GetActorByTID(TAG_KEY_DISPLAY_1_BITS + i);
		if (ActorExists(actor) && actor.IsPersistentMarked())
			remainingKeys--;
	}
	
	return remainingKeys;
}
//------------------------------------------------------------------------------------------------------------------------
void DisplayKeysRemaining()
{
	if (!TimeReached(displayKeysTime))
		return;
	
	displayKeysTime = TimeFromNow(3.0f);
	int msgTime = 180;
	int remainingKeys = GetRemainingKeys();
	if (remainingKeys <= 0)
	{
		Game.PrintLine(Game.GetLocalizedText("$str_005"), 0, msgTime); //this level found
		Game.PrintLine(Game.GetLocalizedText("$str_004"), 1, msgTime); //all keys on
	}
	else if (remainingKeys == 1)
	{
		Game.PrintLine(Game.GetLocalizedText("$str_003"), 0, msgTime); //on this level
		Game.PrintLine(Game.GetLocalizedText("$str_002"), 1, msgTime); //1 Key to Find
	}
	else
	{
		Game.PrintLine(Game.GetLocalizedText("$str_001"), 0, msgTime); //on this level
		Game.PrintLine("" + remainingKeys + " " + Game.GetLocalizedText("$str_000"), 1, msgTime); //x Keys to Find
	}
}
//------------------------------------------------------------------------------------------------------------------------
// Returns true if eventlink was triggered before
//------------------------------------------------------------------------------------------------------------------------
bool EventLinkTrigger(const int tid, const bool triggerLinkTargets = true)
{
	bool wasTriggered;
	kActor@ actor = World.GetActorByTID(tid);
	if (ActorExists(actor))
	{
		wasTriggered = actor.IsPersistentMarked();
		actor.MarkPersistentBit(false);
		if (triggerLinkTargets)
			EventLinkTriggerTarget(actor);
	}
	
	return wasTriggered;
}
//------------------------------------------------------------------------------------------------------------------------
void EventLinkTriggerTarget(kActor@ actor)
{
	int triggerTID = actor.SpawnParams(SPAWNPARAM_TARGETID);
	int triggerScriptID = actor.SpawnParams(SPAWNPARAM_HEALTH);
	if (triggerTID > 0)
		World.TriggerActorsByTID(actor, triggerTID);
	if (triggerScriptID > 0)
		Game.CallDelayedMapScript(triggerScriptID, actor, 0.0f);
}
//------------------------------------------------------------------------------------------------------------------------
bool ActorExists(kActor@ actor)
{
	return actor !is null && !actor.IsStale();
}
//------------------------------------------------------------------------------------------------------------------------
bool ActorIsDead(kActor@ actor)
{
	return actor.Flags() & AF_DEAD != 0;
}
//------------------------------------------------------------------------------------------------------------------------
kActor@ ActorSpawn(const int actorID, kActor@ actorDest)
{
	return ActorFactory.Spawn(actorID, actorDest.Origin().x, actorDest.Origin().y, actorDest.Origin().z, actorDest.Yaw(), actorDest.SectorIndex());
}
//------------------------------------------------------------------------------------------------------------------------
array<kActor@> FindActors(const array<int> &in tids)
{
	array<kActor@> actors;
	for (uint i = 0; i < tids.length(); i++)
	{
		kActor@ actor = World.GetActorByTID(tids[i]);
		if (ActorExists(actor))
			actors.insertLast(actor);
	}
	
	return actors;
}
//------------------------------------------------------------------------------------------------------------------------
array<kActor@> FindActors(const int startTID, const int endTID)
{
	array<kActor@> actors;
	for (int i = startTID; i <= endTID; i++)
	{
		kActor@ actor = World.GetActorByTID(i);
		if (ActorExists(actor))
			actors.insertLast(actor);
	}
	
	return actors;
}
//------------------------------------------------------------------------------------------------------------------------
// Shows player at the actorLocation
//------------------------------------------------------------------------------------------------------------------------
void ShowPlayer(kActor@ actorLocation, const int animID, const int modelVariation)
{
	ShowPlayer(actorLocation.Origin(), actorLocation.SectorIndex(), actorLocation.Yaw(), animID, modelVariation);
}
//------------------------------------------------------------------------------------------------------------------------
// Shows player at the actorLocation
//------------------------------------------------------------------------------------------------------------------------
void ShowPlayer(const kVec3 &in pos, const int sectorIndex, const float yaw, const int animID, const int modelVariation)
{
	kActor@ actor = Player.Actor().CastToActor();
	actor.Flags() &= ~AF_NODRAW;
	actor.ModelVariation() = modelVariation;
	PlayerSetPosition(pos, sectorIndex, yaw);
	PlayerPlayAnim(animID);
}
//------------------------------------------------------------------------------------------------------------------------
void ActorSetPosition(kActor@ actor, kActor@ destActor, const bool floorHeight = false)
{
	ActorSetPosition(actor, destActor.Origin(), destActor.SectorIndex(), floorHeight);
}
//------------------------------------------------------------------------------------------------------------------------
void ActorSetPosition(kActor@ actor, const kVec3 &in pos, const int sectorIndex, const bool floorHeight = false)
{
	actor.Origin() = pos;
	actor.SetSector(sectorIndex);
	if (floorHeight)
		actor.Origin().z = actor.FloorHeight();
}
//------------------------------------------------------------------------------------------------------------------------
void PlayerSetPosition(kActor@ actorLocation, const float yaw = 0.0f, const float pitch = 0.0f, const bool floorHeight = true)
{
	PlayerSetPosition(actorLocation.Origin(), actorLocation.SectorIndex(), yaw, pitch, floorHeight);
}
//------------------------------------------------------------------------------------------------------------------------
void PlayerSetPosition(const kVec3 &in pos, const int sectorIndex, const float yaw = 0.0f, const float pitch = 0.0f, const bool floorHeight = true)
{
	kActor@ actor = Player.Actor().CastToActor();
	ActorSetPosition(actor, pos, sectorIndex, floorHeight);
	actor.Yaw() = yaw;
	actor.Pitch() = pitch;
	actor.Roll() = 0.0f;
	Player.Actor().RecoilPitch() = 0.0f;
	actor.Velocity() = Math::vecZero;
	actor.Movement() = Math::vecZero;
}
//------------------------------------------------------------------------------------------------------------------------
void PlayerPlayAnim(const int animID, const bool blend = false)
{
	int animFlags = 0;
	float animSpeed = 4.0f;
	switch (animID)
	{
		case 2816: //panic
			animSpeed = 10.0f;
			animFlags = ANF_LOOP | ANF_ROOTMOTION;
			break;

		case 2818: //jump out of tunnel with explosion
		case 202: //campaigner death
			animSpeed = 8.0f;
			animFlags = ANF_ROOTMOTION;
			break;

		case 2817: //idle stand
		case 0: //boss victory
		{
			animSpeed = 8.0f;
			animFlags = ANF_LOOP;
			break;
		}
		case 2819: //with explosions
		{
			animSpeed = 5.5f;
			animFlags = ANF_LOOP | ANF_ROOTMOTION;
			break;
		}
		case 2815: //freeze jump fall animation
		case 36: // Death Pit Falling
		{
			animSpeed = 4.0f;
			animFlags = ANF_LOOP;
			break;
		}
		case 2820: //rises from water and looks back up
		case 200: //mantis death
		{
			animSpeed = 4.0f;
			animFlags = 0;
			break;
		}
		case 34: //normal death
		case 201: //falls to ground blocking
		case 2507: //underwater death
		case 2550: //revive
		case 2801: //intro waits with bow and then fires it
		case 2810: //picked up key
		{
			animSpeed = 8.0f;
			animFlags = 0;
			break;
		}
	}

	if (blend)
		Player.Actor().AnimState().Blend(animID, animSpeed, 8.0f, animFlags);
	else
		Player.Actor().AnimState().Set(animID, animSpeed, animFlags);
}
//------------------------------------------------------------------------------------------------------------------------
bool CinemaIsShowing()
{
	return Camera.CinematicState() >= 2;
}
//------------------------------------------------------------------------------------------------------------------------
bool CinemaIsFinished()
{
	return Camera.CinematicState() <= 0 || Camera.CinematicState() >= 5;
}
//------------------------------------------------------------------------------------------------------------------------
float TimeFromNow(const float timeOffset)
{
	return mapTime + timeOffset;
}
//------------------------------------------------------------------------------------------------------------------------
bool TimeReached(const float timeTarget)
{
	return mapTime >= timeTarget;
}
//------------------------------------------------------------------------------------------------------------------------
void WaitUntil(MAPWAITFUNC @func)
{
	if (func !is null) while (!func()) { delay(0.0f); }
}
//------------------------------------------------------------------------------------------------------------------------
